using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.Net.Sockets;
using System.Collections;
using System.IO;
using System.Text.RegularExpressions;
using RE = System.Text.RegularExpressions.Regex;
using System.Security.Cryptography.X509Certificates;
using System.Web;

/***************************************************************************************************************************************************
 * *ļHttpProc.cs
 * *ˣHeDaode
 * * ڣ2007.09.01
 * * ʵHTTPЭеGETPOST
 * *ʹ ãHttpProc.WebClient client = new HttpProc.WebClient();
            client.Encoding = System.Text.Encoding.Default;//Ĭϱ뷽ʽҪ
            client.OpenRead("http://www.baidu.com");//ͨget
            MessageBox.Show(client.RespHtml);//ȡصҳԴ
            client.DownloadFile("http://www.codepub.com/upload/163album.rar",@"C:\163album.rar");//ļ
            client.OpenRead("http://passport.baidu.com/?login","username=zhangsan&password=123456");//ύ˴ǵ¼ٶȵʾ
            client.UploadFile("http://hiup.baidu.com/zhangsan/upload", @"file1=D:\1.mp3");//ϴļ
            client.UploadFile("http://hiup.baidu.com/zhangsan/upload", "folder=myfolder&size=4003550",@"file1=D:\1.mp3");//ύıļı
*****************************************************************************************************************************************************/

namespace RenrenImportProcess
{
    ///<summary>
    ///ϴ¼ί
    ///</summary>
    ///<param name="sender"></param>
    ///<param name="e"></param>
    public delegate void WebClientUploadEvent(object sender, HttpProc.UploadEventArgs e);

    ///<summary>
    ///¼ί
    ///</summary>
    ///<param name="sender"></param>
    ///<param name="e"></param>
    public delegate void WebClientDownloadEvent(object sender, HttpProc.DownloadEventArgs e);


    ///<summary>
    ///ϴ¼
    ///</summary>
    public struct UploadEventArgs
    {
        ///<summary>
        ///ϴܴС
        ///</summary>
        public long totalBytes;
        ///<summary>
        ///ѷݴС
        ///</summary>
        public long bytesSent;
        ///<summary>
        ///ͽ(0-1)
        ///</summary>
        public double sendProgress;
        ///<summary>
        ///ٶBytes/s
        ///</summary>
        public double sendSpeed;
    }

    ///<summary>
    ///¼
    ///</summary>
    public struct DownloadEventArgs
    {
        ///<summary>
        ///ܴС
        ///</summary>
        public long totalBytes;
        ///<summary>
        ///ѽݴС
        ///</summary>
        public long bytesReceived;
        ///<summary>
        ///ݽ(0-1)
        ///</summary>
        public double ReceiveProgress;
        ///<summary>
        ///ǰ
        ///</summary>
        public byte[] receivedBuffer;
        ///<summary>
        ///ٶBytes/s
        ///</summary>
        public double receiveSpeed;
    }

    ///<summary>
    ///ʵWEBͺͽ
    ///</summary>
    public class WebClient
    {
        private WebHeaderCollection requestHeaders, responseHeaders;
        private TcpClient clientSocket;
        private MemoryStream postStream;
        private Encoding encoding = Encoding.Default;
        private const string BOUNDARY = "---------------------------7da3cb1880518";
        private const int SEND_BUFFER_SIZE = 10245;
        private const int RECEIVE_BUFFER_SIZE = 10245;
        private string cookie = "";
        private string respHtml = "";
        private string strRequestHeaders = "";
        private string strResponseHeaders = "";
        private int statusCode = 0;
        private bool isCanceled = false;
        public static event WebClientUploadEvent UploadProgressChanged;
        public static event WebClientDownloadEvent DownloadProgressChanged;

        ///<summary>
        ///ʼWebClient
        ///</summary>
        public WebClient()
        {
            responseHeaders = new WebHeaderCollection();
            requestHeaders = new WebHeaderCollection();
        }


        ///<summary>
        ///ȡָURLı
        ///</summary>
        ///<param name="URL">ĵַ</param>
        ///<returns>Ӧı</returns>
        public string OpenRead(string URL)
        {
            requestHeaders.Add("Connection", "close");
            SendRequestData(URL, "GET");
            return GetHtml();
        }


        //֤޷ʵ
        class CertPolicy : ICertificatePolicy
        {
            public bool CheckValidationResult(ServicePoint srvpt, X509Certificate cert, WebRequest req, int certprb)
            { return true; }
        }

        ///<summary>
        ///httpsЭ
        ///</summary>
        ///<param name="URL">urlַ</param>
        ///<param name="strPostdata">͵</param>
        ///<returns></returns>
        public string OpenReadWithHttps(string URL, string strPostdata)
        {
            ServicePointManager.CertificatePolicy = new CertPolicy();
            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(URL);
            request.CookieContainer = new CookieContainer();
            request.Method = "POST";
            request.Accept = "*/*";
            request.ContentType = "application/x-www-form-urlencoded";
            byte[] buffer = this.encoding.GetBytes(strPostdata);
            request.ContentLength = buffer.Length;
            request.GetRequestStream().Write(buffer, 0, buffer.Length);
            HttpWebResponse response = (HttpWebResponse)request.GetResponse();
            StreamReader reader = new StreamReader(response.GetResponseStream(), encoding);
            this.respHtml = reader.ReadToEnd();
            foreach (System.Net.Cookie ck in response.Cookies)
            {
                this.cookie += ck.Name + "=" + ck.Value + ";";
            }
            reader.Close();
            return respHtml;
        }

        ///<summary>
        ///ȡָURLı
        ///</summary>
        ///<param name="URL">ĵַ</param>
        ///<param name="postData">͵ı</param>
        ///<returns>Ӧı</returns>
        public string OpenRead(string URL, string postData)
        {
            postData = HttpUtility.UrlEncode(postData);
            byte[] sendBytes = encoding.GetBytes(postData);
            postStream = new MemoryStream();
            postStream.Write(sendBytes, 0, sendBytes.Length);

            requestHeaders.Add("Content-Length", postStream.Length.ToString());
            requestHeaders.Add("Content-Type", "application/x-www-form-urlencoded");
            requestHeaders.Add("Connection", "close");

            SendRequestData(URL, "POST");
            return GetHtml();
        }


        ///<summary>
        ///ȡָURL
        ///</summary>
        ///<param name="URL">ĵַ</param>
        ///<param name="postData">͵</param>
        ///<returns>Ӧ</returns>
        public Stream GetStream(string URL, string postData)
        {
            byte[] sendBytes = encoding.GetBytes(postData);
            postStream = new MemoryStream();
            postStream.Write(sendBytes, 0, sendBytes.Length);

            requestHeaders.Add("Content-Length", postStream.Length.ToString());
            requestHeaders.Add("Content-Type", "application/x-www-form-urlencoded");
            requestHeaders.Add("Connection", "close");

            SendRequestData(URL, "POST");

            MemoryStream ms = new MemoryStream();
            SaveNetworkStream(ms);
            return ms;
        }


        ///<summary>
        ///ϴļ
        ///</summary>
        ///<param name="URL">ĵַ</param>
        ///<param name="fileField">ļ(ʽ:file1=C:\test.mp3&file2=C:\test.jpg)</param>
        ///<returns>Ӧı</returns>
        public string UploadFile(string URL, string fileField)
        {
            return UploadFile(URL, "", fileField);
        }


        ///<summary>
        ///ϴļݵ
        ///</summary>
        ///<param name="URL">ַ</param>
        ///<param name="textField">ı(ʽΪ:name1=value1&name2=value2)</param>
        ///<param name="fileField">ļ(ʽ:file1=C:\test.mp3&file2=C:\test.jpg)</param>
        ///<returns>Ӧı</returns>
        public string UploadFile(string URL, string textField, string fileField, bool fast)
        {

            postStream = new MemoryStream();

            if (textField != "" && fileField != "")
            {
                WriteTextField(textField);
                WriteFileField(fileField);
            }
            else if (fileField != "")
            {
                WriteFileField(fileField);
            }
            else if (textField != "")
            {
                WriteTextField(textField);
            }
            else
                throw new Exception("ıļͬʱΪա");

            //д
            byte[] buffer = encoding.GetBytes("--" + BOUNDARY + "--\r\n");
            postStream.Write(buffer, 0, buffer.Length);

            //ͷ
            requestHeaders.Add("Referer", URL.Replace("upload", ""));
            requestHeaders.Add("Content-Length", postStream.Length.ToString());
            requestHeaders.Add("Content-Type", "multipart/form-data; boundary=" + BOUNDARY);
            requestHeaders.Add("Connection", "Keep-Alive");

            //
            SendRequestData(URL, "POST", true);


            if (!fast)
                return GetHtml();
            else
            {
                //clientSocket.Close();
                return string.Empty;
            }
        }
        ///<summary>
        ///ϴļݵ
        ///</summary>
        ///<param name="URL">ַ</param>
        ///<param name="textField">ı(ʽΪ:name1=value1&name2=value2)</param>
        ///<param name="fileField">ļ(ʽ:file1=C:\test.mp3&file2=C:\test.jpg)</param>
        ///<returns>Ӧı</returns>
        public string UploadFile(string URL, string textField, string fileField)
        {
            return UploadFile(URL, textField, fileField, false);
        }


        ///<summary>
        ///ıӵ
        ///</summary>
        ///<param name="textField">ı</param>
        private void WriteTextField(string textField)
        {
            string[] strArr = RE.Split(textField, "&");
            textField = "";
            foreach (string var in strArr)
            {
                Match M = RE.Match(var, "([^=]+)=(.+)");
                textField += "--" + BOUNDARY + "\r\n";
                textField += "Content-Disposition: form-data; name=\"" + M.Groups[1].Value + "\"\r\n\r\n" + M.Groups[2].Value + "\r\n";
            }
            byte[] buffer = encoding.GetBytes(textField);
            postStream.Write(buffer, 0, buffer.Length);
        }

        ///<summary>
        ///ļӵ
        ///</summary>
        ///<param name="fileField">ļ</param>
        private void WriteFileField(string fileField)
        {
            string filePath = "";
            int count = 0;
            string[] strArr = RE.Split(fileField, "&");
            foreach (string var in strArr)
            {
                Match M = RE.Match(var, "([^=]+)=(.+)");
                filePath = M.Groups[2].Value;
                fileField = "--" + BOUNDARY + "\r\n";
                fileField += "Content-Disposition: form-data; name=\"" + M.Groups[1].Value + "\"; filename=\"" + Path.GetFileName(filePath) + "\"\r\n";
                fileField += "Content-Type: image/pjpeg\r\n\r\n";

                byte[] buffer = encoding.GetBytes(fileField);
                postStream.Write(buffer, 0, buffer.Length);

                //ļ
                FileStream fs = new FileStream(System.Web.HttpUtility.UrlDecode(filePath), FileMode.Open, FileAccess.Read);
                buffer = new byte[50000];

                do
                {
                    count = fs.Read(buffer, 0, buffer.Length);
                    postStream.Write(buffer, 0, count);
                }
                while (count > 0);

                fs.Close();
                buffer = encoding.GetBytes("\r\n");
                postStream.Write(buffer, 0, buffer.Length);
            }
        }

        ///<summary>
        ///ָURL
        ///</summary>
        ///<param name="URL">ַ</param>
        ///<returns></returns>
        public Stream DownloadData(string URL)
        {
            requestHeaders.Add("Connection", "close");
            SendRequestData(URL, "GET");
            MemoryStream ms = new MemoryStream();
            SaveNetworkStream(ms, true);
            return ms;
        }


        ///<summary>
        ///ָURLļ
        ///</summary>
        ///<param name="URL">ļURLַ</param>
        ///<param name="fileName">ļ·,ļ(:C:\test.jpg)</param>
        public void DownloadFile(string URL, string fileName)
        {
            requestHeaders.Add("Connection", "close");
            SendRequestData(URL, "GET");
            FileStream fs = new FileStream(fileName, FileMode.Create);
            SaveNetworkStream(fs, true);
            fs.Close();
        }

        ///<summary>
        ///
        ///</summary>
        ///<param name="URL">ַ</param>
        ///<param name="method">POSTGET</param>
        ///<param name="showProgress">Ƿʾϴ</param>
        private void SendRequestData(string URL, string method, bool showProgress)
        {
            clientSocket = new TcpClient();
            Uri URI = new Uri(URL);
            clientSocket.Connect(URI.Host, URI.Port);

            requestHeaders.Add("Host", URI.Host);
            byte[] request = GetRequestHeaders(method + " " + URI.PathAndQuery + " HTTP/1.1");
            clientSocket.Client.Send(request);

            //ʵݾͷ
            if (postStream != null)
            {
                byte[] buffer = new byte[SEND_BUFFER_SIZE];
                int count = 0;
                Stream sm = clientSocket.GetStream();
                postStream.Position = 0;

                UploadEventArgs e = new UploadEventArgs();
                e.totalBytes = postStream.Length;
                System.Diagnostics.Stopwatch timer = new System.Diagnostics.Stopwatch();//ʱ
                timer.Start();
                do
                {
                    //ȡƳ
                    if (isCanceled) { break; }

                    //ȡҪ͵
                    count = postStream.Read(buffer, 0, buffer.Length);
                    //͵
                    sm.Write(buffer, 0, count);

                    //Ƿʾ
                    if (showProgress)
                    {
                        //¼
                        e.bytesSent += count;
                        e.sendProgress = (double)e.bytesSent / (double)e.totalBytes;
                        double t = timer.ElapsedMilliseconds / 1000;
                        t = t <= 0 ? 1 : t;
                        e.sendSpeed = (double)e.bytesSent / t;
                        if (UploadProgressChanged != null) { UploadProgressChanged(this, e); }
                    }

                } while (count > 0);
                timer.Stop();

                //string s = System.Text.Encoding.UTF8.GetString(buffer);
                System.Text.Encoding.Default.GetString(buffer);
                postStream.Close();
                //postStream.Dispose();
                postStream = null;
            }//end if
        }

        ///<summary>
        ///
        ///</summary>
        ///<param name="URL">URLַ</param>
        ///<param name="method">POSTGET</param>
        private void SendRequestData(string URL, string method)
        {
            SendRequestData(URL, method, false);
        }


        ///<summary>
        ///ȡͷֽ
        ///</summary>
        ///<param name="request">POSTGET</param>
        ///<returns>ͷֽ</returns>
        private byte[] GetRequestHeaders(string request)
        {
            requestHeaders.Add("Accept", "*/*");
            requestHeaders.Add("Accept-Language", "zh-cn");
            requestHeaders.Add("User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.2; SV1; .NET CLR 1.1.4322; .NET CLR 2.0.50727)");

            string headers = request + "\r\n";

            foreach (string key in requestHeaders)
            {
                headers += key + ":" + requestHeaders[key] + "\r\n";
            }

            //CookieʹCookie
            if (cookie != "") { headers += "Cookie:" + cookie + "\r\n"; }

            //Уͷ
            headers += "\r\n";

            strRequestHeaders = headers;
            requestHeaders.Clear();
            return encoding.GetBytes(headers);
        }



        ///<summary>
        ///ȡӦı
        ///</summary>
        ///<returns>Ӧı</returns>
        private string GetHtml()
        {
            using (MemoryStream ms = new MemoryStream())
            {
                SaveNetworkStream(ms);//浽ڴ
                using (StreamReader sr = new StreamReader(ms, encoding))
                {
                    respHtml = sr.ReadToEnd();
                    sr.Close();
                }
                ms.Close();
            }
            return respHtml;
        }

        ///<summary>
        ///浽ָ
        ///</summary>
        ///<param name="toStream">λ</param>
        ///<param name="needProgress">Ƿʾ</param>
        private void SaveNetworkStream(Stream toStream, bool showProgress)
        {
            //ȡҪ
            NetworkStream NetStream = clientSocket.GetStream();

            byte[] buffer = new byte[RECEIVE_BUFFER_SIZE];
            int count = 0, startIndex = 0;

            using (MemoryStream ms = new MemoryStream())
            {
                for (int i = 0; i < 3; i++)
                {
                    count = NetStream.Read(buffer, 0, 500);
                    ms.Write(buffer, 0, count);
                }

                if (ms.Length == 0) { NetStream.Close(); throw new Exception("Զ̷ûӦ"); }

                buffer = ms.GetBuffer();
                count = (int)ms.Length;

                GetResponseHeader(buffer, out startIndex);//ӦȡӦͷӦʵ
                count -= startIndex;
                toStream.Write(buffer, startIndex, count);

                DownloadEventArgs e = new DownloadEventArgs();

                if (responseHeaders["Content-Length"] != null)
                { e.totalBytes = long.Parse(responseHeaders["Content-Length"]); }
                else
                { e.totalBytes = -1; }

                //ʱ
                System.Diagnostics.Stopwatch timer = new System.Diagnostics.Stopwatch();
                timer.Start();

                do
                {
                    //ȡƳ
                    if (isCanceled) { break; }

                    //ʾؽ
                    if (showProgress)
                    {
                        e.bytesReceived += count;
                        e.ReceiveProgress = (double)e.bytesReceived / (double)e.totalBytes;

                        byte[] tempBuffer = new byte[count];
                        Array.Copy(buffer, startIndex, tempBuffer, 0, count);
                        e.receivedBuffer = tempBuffer;

                        double t = (timer.ElapsedMilliseconds + 0.1) / 1000;
                        e.receiveSpeed = (double)e.bytesReceived / t;

                        startIndex = 0;
                        if (DownloadProgressChanged != null) { DownloadProgressChanged(this, e); }
                    }

                    //ȡ·ݵ
                    count = NetStream.Read(buffer, 0, buffer.Length);

                    //ݱ浽ָ
                    toStream.Write(buffer, 0, count);
                } while (count > 0);

                timer.Stop();//رռʱ

                if (responseHeaders["Content-Length"] != null)
                {
                    toStream.SetLength(long.Parse(responseHeaders["Content-Length"]));
                }
                //else
                //{
                //    toStream.SetLength(toStream.Length);
                //    responseHeaders.Add("Content-Length", toStream.Length.ToString());//Ӧͷ
                //}

                toStream.Position = 0;

                //ر
                NetStream.Close();
            }
            clientSocket.Close();
        }


        ///<summary>
        ///浽ָ
        ///</summary>
        ///<param name="toStream">λ</param>
        private void SaveNetworkStream(Stream toStream)
        {
            SaveNetworkStream(toStream, false);
        }



        ///<summary>
        ///ӦȥӦͷ
        ///</summary>
        ///<param name="buffer"></param>
        private void GetResponseHeader(byte[] buffer, out int startIndex)
        {
            responseHeaders.Clear();
            string html = encoding.GetString(buffer);
            StringReader sr = new StringReader(html);

            int start = html.IndexOf("\r\n\r\n") + 4;//ҵλ
            strResponseHeaders = html.Substring(0, start);//ȡӦͷı

            //ȡӦ״̬
            //
            if (sr.Peek() > -1)
            {
                //һַ
                string line = sr.ReadLine();

                //ַ,ȡӦ״̬
                Match M = RE.Match(line, @"\d\d\d");
                if (M.Success)
                {
                    statusCode = int.Parse(M.Value);
                }
            }

            //ȡӦͷ
            //
            while (sr.Peek() > -1)
            {
                //һַ
                string line = sr.ReadLine();

                //ǿ
                if (line != "")
                {
                    //ַȡӦͷ
                    Match M = RE.Match(line, "([^:]+):(.+)");
                    if (M.Success)
                    {
                        try
                        {        //Ӧͷ
                            responseHeaders.Add(M.Groups[1].Value.Trim(), M.Groups[2].Value.Trim());
                        }
                        catch
                        { }


                        //ȡCookie
                        if (M.Groups[1].Value == "Set-Cookie")
                        {
                            M = RE.Match(M.Groups[2].Value, "[^=]+=[^;]+");
                            cookie += M.Value.Trim() + ";";
                        }
                    }

                }
                //ǿУӦͷӦʵ忪ʼӦͷӦʵһи
                else
                {
                    //ӦͷûʵСͷԶӦʵһлȡʵС
                    if (responseHeaders["Content-Length"] == null && sr.Peek() > -1)
                    {
                        //Ӧʵһ
                        line = sr.ReadLine();

                        //пǷʵС
                        Match M = RE.Match(line, "~[0-9a-fA-F]{1,15}");

                        if (M.Success)
                        {
                            //16ƵʵСַתΪ10
                            int length = int.Parse(M.Value, System.Globalization.NumberStyles.AllowHexSpecifier);
                            responseHeaders.Add("Content-Length", length.ToString());//Ӧͷ
                            strResponseHeaders += M.Value + "\r\n";
                        }
                    }
                    break;//ѭ 
                }//End If
            }//End While

            sr.Close();

            //ʵ忪ʼ
            startIndex = encoding.GetBytes(strResponseHeaders).Length;
        }


        ///<summary>
        ///ȡϴ,ҪʼStart
        ///</summary>
        public void Cancel()
        {
            isCanceled = true;
        }

        ///<summary>
        ///ϴأҪȡCancel
        ///</summary>
        public void Start()
        {
            isCanceled = false;
        }

        //*************************************************************
        //Ϊ
        //*************************************************************

        ///<summary>
        ///ȡͷ
        ///</summary>
        public WebHeaderCollection RequestHeaders
        {
            set { requestHeaders = value; }
            get { return requestHeaders; }
        }

        ///<summary>
        ///ȡӦͷ
        ///</summary>
        public WebHeaderCollection ResponseHeaders
        {
            get { return responseHeaders; }
        }

        ///<summary>
        ///ȡͷı
        ///</summary>
        public string StrRequestHeaders
        {
            get { return strRequestHeaders; }
        }

        ///<summary>
        ///ȡӦͷı
        ///</summary>
        public string StrResponseHeaders
        {
            get { return strResponseHeaders; }
        }

        ///<summary>
        ///ȡCookie
        ///</summary>
        public string Cookie
        {
            set { cookie = value; }
            get { return cookie; }
        }

        ///<summary>
        ///ȡñ뷽ʽ(ĬΪϵͳĬϱ뷽ʽ)
        ///</summary>
        public Encoding Encoding
        {
            set { encoding = value; }
            get { return encoding; }
        }

        ///<summary>
        ///ȡӦı
        ///</summary>
        public string RespHtml
        {
            get { return respHtml; }
        }


        ///<summary>
        ///ȡӦ״̬
        ///</summary>
        public int StatusCode
        {
            get { return statusCode; }
        }
    }
}